SystemOrganization addCategory: #'RSS-Examples'!

RRComponent subclass: #RRChangesDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RSS-Examples'!

!RRChangesDemo class methodsFor: 'testing' stamp: 'mb 10/28/2006 08:29'!
canBeRoot
	^true! !

!RRChangesDemo class methodsFor: 'accessing' stamp: 'mb 11/1/2006 17:52'!
description
	^'An RSS feed about recent changes to image '
		, SeasidePlatformSupport shortImageName
! !

!RRChangesDemo class methodsFor: 'initialization' stamp: 'jf 10/26/2008 17:59'!
initialize
	(WAAdmin register: RRRssHandler at: 'examples/changes.rss')
		rootComponentClass: self! !

!RRChangesDemo methodsFor: 'rendering' stamp: 'jf 11/4/2008 12:50'!
baseUrl
	^ self requestContext entryPoint baseUrl! !

!RRChangesDemo methodsFor: 'model' stamp: 'mb 10/28/2006 08:41'!
dateOfImage
	^DateAndTime now! !

!RRChangesDemo methodsFor: 'model' stamp: 'mb 10/28/2006 08:41'!
dateOfLastChange
	^DateAndTime now! !

!RRChangesDemo methodsFor: 'model' stamp: 'mb 10/28/2006 16:19'!
recentChanges
	^SeasidePlatformSupport recentChanges
! !

!RRChangesDemo methodsFor: 'rendering' stamp: 'jf 10/21/2008 21:02'!
renderChange: aChange on: rss
	| url |
	url := self baseUrl
		takeServerParametersFromRequest: self requestContext request;
		addToPath: WABrowser applicationName;
		yourself.
	aChange addParametersTo: url.
	rss item: [
		rss title: aChange title.
		rss author: aChange author. "has to be an email address"
		rss link: url.
		rss description: [
				rss renderHtml: [ :html |
					self renderDescription:  aChange description on: html ] ].
		rss publicationDate: (RRRfc822DateTime newDateAndTime: aChange timestamp) ]! !

!RRChangesDemo methodsFor: 'rendering' stamp: 'pmm 4/1/2008 07:02'!
renderChannelOn: rss
	rss title: [
		rss text: 'Recent changes to the Seaside image'.
		rss space.
		rss text: SeasidePlatformSupport shortImageName].
	rss link: self baseUrl. "Should go to the default app if defined"
	rss description: [
		rss text: 'Changes that were recently made to the Seaside image.'.
		rss space.
		rss text: SeasidePlatformSupport imageName].
	rss language englishUnitedStates.
	rss publicationDate:
			(RRRfc822DateTime newDateAndTime: self dateOfLastChange).
	rss lastBuildDate:
			(RRRfc822DateTime newDateAndTime: self dateOfImage).
	rss defaultDocumentation.
	rss defaultGenerator.! !

!RRChangesDemo methodsFor: 'rendering' stamp: 'mb 10/28/2006 17:10'!
renderContentOn: rss
	self renderChannelOn: rss.
	self renderRecentChangesOn: rss.
! !

!RRChangesDemo methodsFor: 'rendering' stamp: 'pmm 1/5/2008 07:39'!
renderDescription: aString on: html
	| aStream |
	aString isNil ifTrue: [ ^self ].
	aStream := aString readStream.
	html preformatted: [
		html text: aStream nextLine.
		aStream atEnd ifFalse: [
			html render: Character cr.
			html text: aStream upToEnd ] ].
! !

!RRChangesDemo methodsFor: 'rendering' stamp: 'mb 10/28/2006 17:00'!
renderRecentChangesOn: rss
	self recentChanges do: [:each | self renderChange: each on: rss].
! !

RRComponent subclass: #RRDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RSS-Examples'!

!RRDemo class methodsFor: 'testing' stamp: 'pmm 9/23/2006 12:33'!
canBeRoot
	^true! !

!RRDemo class methodsFor: 'accessing' stamp: 'pmm 10/23/2006 11:11'!
description
	^'RSS Demo'! !

!RRDemo class methodsFor: 'class initialization' stamp: 'pmm 10/26/2008 23:38'!
initialize
	(WAAdmin register: RRRssHandler at: 'examples/demo.rss')
		rootComponentClass: self! !

!RRDemo methodsFor: 'private' stamp: 'pmm 10/23/2006 10:50'!
firstPublicationDate
	^DateAndTime
		year: 2003
		month: 6
		day: 3
		hour: 9
		minute: 39
		second: 21! !

!RRDemo methodsFor: 'private' stamp: 'pmm 10/23/2006 10:52'!
fourthPublicationDate
	^DateAndTime
		year: 2003
		month: 5
		day: 20
		hour: 8
		minute: 56
		second: 02! !

!RRDemo methodsFor: 'rendering' stamp: 'pmm 9/23/2006 12:18'!
renderChannelOn: rss
	rss title: 'Liftoff News'.
	rss link: 'http://liftoff.msfc.nasa.gov/'.
	rss description: 'Liftoff to Space Exploration.'.
	rss language englishUnitedStates.
	rss publicationDate: 'Tue, 10 Jun 2003 04:00:00 GMT'.
	rss lastBuildDate: 'Tue, 10 Jun 2003 09:41:01 GMT'.
	rss defaultDocumentation.
	rss generator: 'Weblog Editor 2.0'.
	rss managingEditor: 'editor@example.com'.
	rss webMaster: 'webmaster@example.com'! !

!RRDemo methodsFor: 'rendering' stamp: 'pmm 9/23/2006 12:26'!
renderContentOn: rss
	self renderChannelOn: rss.
	self renderFirstItemOn: rss.
	self renderSecondItemOn: rss.
	self renderThirdItemOn: rss.
	self renderFourthtemOn: rss! !

!RRDemo methodsFor: 'rendering' stamp: 'pmm 10/23/2006 10:50'!
renderFirstItemOn: rss
	rss item: [
		rss title: 'Star City'.
		rss author: 'joesmith@example.com (Joe Smith)'.
		rss link: 'http://liftoff.msfc.nasa.gov/news/2003/news-starcity.asp'.
		rss description: 'How do Americans get ready to work with Russians aboard the International Space Station? They take a crash course in culture, language and protocol at Russia''s Star City.'.
		rss publicationDate: (RRRfc822DateTime newDateAndTime: self firstPublicationDate).
		rss guid: 'http://liftoff.msfc.nasa.gov/2003/06/03.html#item573' ]! !

!RRDemo methodsFor: 'rendering' stamp: 'pmm 10/12/2006 23:44'!
renderFourthtemOn: rss
	rss item: [
		rss title: 'Astronauts'' Dirty Laundry'.
		rss author: (RREmailAddress address: 'joesmith@example.com').
		rss link: 'http://liftoff.msfc.nasa.gov/news/2003/news-laundry.asp'.
		rss description: 'Compared to earlier spacecraft, the International Space Station has many luxuries, but laundry facilities are not one of them. Instead, astronauts have other options.'.
		rss publicationDate: 'Tue, 20 May 2003 08:56:02 GMT'.
		rss guid: 'http://liftoff.msfc.nasa.gov/2003/05/20.html#item570' ]! !

!RRDemo methodsFor: 'rendering' stamp: 'pmm 10/23/2006 10:49'!
renderSecondItemOn: rss
	rss item: [
		rss title: 'Space Exploration'.
		rss author: 'Joe Smith <joesmith@example.com>'.
		rss link: 'http://liftoff.msfc.nasa.gov/'.
		rss description: 'Sky watchers in Europe, Asia, and parts of Alaska and Canada will experience a partial eclipse of the Sun on Saturday, May 31st.'.
		rss publicationDate: (RRRfc822DateTime newUtc: self secondPublicationDate).
		rss guid: 'http://liftoff.msfc.nasa.gov/2003/05/30.html#item572' ]! !

!RRDemo methodsFor: 'rendering' stamp: 'pmm 10/23/2006 10:49'!
renderThirdItemOn: rss
	rss item: [
		rss title: 'The Engine That Does More'.
		rss author: (RREmailAddress address: 'joesmith@example.com' username: 'Joe Smith').
		rss link: 'http://liftoff.msfc.nasa.gov/news/2003/news-VASIMR.asp'.
		rss description: 'Before man travels to Mars, NASA hopes to design new engines that will let us fly through the Solar System more quickly.  The proposed VASIMR engine would do that.'.
		rss publicationDate: (RRRfc822DateTime dateAndTime: self thirdPublicationDate timezoneString: 'EST').
		rss guid: 'http://liftoff.msfc.nasa.gov/2003/05/27.html#item571' ]! !

!RRDemo methodsFor: 'private' stamp: 'pmm 10/23/2006 10:49'!
secondPublicationDate
	^DateAndTime
		year: 2003
		month: 5
		day: 30
		hour: 11
		minute: 6
		second: 42! !

!RRDemo methodsFor: 'private' stamp: 'pmm 10/23/2006 10:49'!
thirdPublicationDate
	^DateAndTime
		year: 2003
		month: 5
		day: 27
		hour: 8
		minute: 37
		second: 32! !

!WAPackage class methodsFor: '*RSS-Examples' stamp: 'jf 10/23/2008 11:59'!
rssExamples
	^ self new
		name: 'RSS-Examples';
		description: 'foo';
		yourself! !

Object subclass: #RRChange
	instanceVariableNames: 'timestamp author title description changedClass changedSelector sourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RSS-Examples'!

!RRChange methodsFor: 'api' stamp: 'mb 11/1/2006 17:22'!
addParametersTo: anUrl
	self hasChangedClass ifFalse: [^self].
	anUrl addParameter: 'class' value: self changedClassName.
	self hasChangedSelector ifTrue: [
		anUrl addParameter: 'method' value: self changedSelector ].
	self isMeta ifTrue: [
		anUrl addParameter: 'meta']
! !

!RRChange methodsFor: 'accessing' stamp: 'mb 10/29/2006 19:12'!
author
	^author! !

!RRChange methodsFor: 'accessing' stamp: 'mb 10/29/2006 19:11'!
author: anObject
	author := anObject! !

!RRChange methodsFor: 'accessing' stamp: 'mb 10/28/2006 16:16'!
changedClass
	^ changedClass! !

!RRChange methodsFor: 'accessing' stamp: 'mb 10/28/2006 16:16'!
changedClass: anObject
	changedClass := anObject! !

!RRChange methodsFor: 'api' stamp: 'mb 11/1/2006 17:22'!
changedClassName
	self hasChangedClass ifFalse: [^nil].
	^ self changedClass theNonMetaClass fullName! !

!RRChange methodsFor: 'accessing' stamp: 'mb 10/28/2006 16:34'!
changedSelector
	^ changedSelector! !

!RRChange methodsFor: 'accessing' stamp: 'mb 10/28/2006 16:34'!
changedSelector: aSymbol
	changedSelector := aSymbol! !

!RRChange methodsFor: 'accessing' stamp: 'mb 11/2/2006 10:50'!
description
	^description ifNil: [ self sourceCode ].! !

!RRChange methodsFor: 'accessing' stamp: 'mb 10/30/2006 06:51'!
description: aString
	description := aString! !

!RRChange methodsFor: 'testing' stamp: 'mb 11/6/2006 07:48'!
hasChangedClass
	"Some VW changes are not about any specific class"
	^self changedClass notNil! !

!RRChange methodsFor: 'testing' stamp: 'mb 11/1/2006 17:21'!
hasChangedSelector
	^self changedSelector notNil! !

!RRChange methodsFor: 'testing' stamp: 'mb 10/29/2006 11:17'!
isMeta
	^self changedClass isMeta! !

!RRChange methodsFor: 'accessing' stamp: 'mb 11/2/2006 10:03'!
sourceCode
	^sourceCode! !

!RRChange methodsFor: 'accessing' stamp: 'mb 11/2/2006 10:04'!
sourceCode: aString
	sourceCode := aString! !

!RRChange methodsFor: 'api' stamp: 'mb 11/2/2006 10:36'!
sourceCodeLimitedTo: max
	self sourceCode ifNil: [ ^String new ].
	^self sourceCode copyFrom: 1 to: (max min: self sourceCode size)! !

!RRChange methodsFor: 'accessing' stamp: 'mb 10/29/2006 19:12'!
timestamp
	^timestamp! !

!RRChange methodsFor: 'accessing' stamp: 'mb 10/29/2006 19:12'!
timestamp: aTimestamp
	timestamp := aTimestamp! !

!RRChange methodsFor: 'accessing' stamp: 'mb 11/2/2006 10:24'!
title
	^title! !

!RRChange methodsFor: 'accessing' stamp: 'mb 11/2/2006 10:24'!
title: aString
	title := aString! !

WAFileLibrary subclass: #RRStylesOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RSS-Examples'!

!RRStylesOne methodsFor: 'css' stamp: 'pmm 4/20/2007 23:04'!
selectorsToInclude
	^#(
		styleCss
	)! !

!RRStylesOne methodsFor: 'css' stamp: 'pmm 4/20/2007 23:03'!
styleCss
	^'
rss {
	display: block;
	font-family: verdana, arial;
}
title {
	display: block;
	margin: 5px;
	padding: 2px;
	color: gray;
	border-bottom: 1px solid silver;
}
link {
	display: block;
	font-size: small;
	padding-left: 10px;
}
item {
	display: block;
	padding: 2px 30px 2px 30px;
}
docs {
	display: block;
	background-color: #ffffe6;
	margin: 20px;
	text-align: center;
	padding: 5px;
	color: #7f7f7f;
	border: 1px solid silver;
}
/* all hidden elements */
language, lastBuildDate, ttl, guid, category, description, pubDate {
	display: none;
}
'! !

WAFileLibrary subclass: #RRStylesThree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RSS-Examples'!

!RRStylesThree methodsFor: 'xslt' stamp: 'pmm 4/20/2007 23:13'!
styleXsl
	^'<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/rss">
 	<html>
 	<head>
 	    <link href="some-more-work-to-do-here.css" rel="stylesheet" type="text/css" />
 	    <style type="text/css">
 	    body {
 	        font-size:0.83em;
 	    }
 	    </style>
 	</head>
 	<body>
 	    <div id="logo">
 	        <xsl:element name="a">
 	            <xsl:attribute name="href">
 	                <xsl:value-of select="channel/link" />
 	            </xsl:attribute>
 	            <xsl:value-of select="channel/title" />
 	        </xsl:element>
 	    </div>
 	    <div class="Snippet" style="border-width:0; background-color:#FFF; margin:1em">
 	        <div class="titleWithLine">
 	            <xsl:value-of select="channel/description" />
 	        </div>
 	        <dl style="padding-right:1em">
 	            <xsl:for-each select="channel/item">
 	                <dd>
 	                    <xsl:element name="a">
 	                        <xsl:attribute name="href">
 	                            <xsl:value-of select="link"/>
 	                        </xsl:attribute>
 	                        <xsl:value-of select="title"/>
 	                    </xsl:element>
 	                </dd>
 	                <dt>
 	                    <xsl:value-of select="description" /><br />
 	                    <span class="comments"><xsl:value-of select="pubDate" /></span>
 	                </dt>
 	            </xsl:for-each>
 	        </dl>
 	    </div>
 	    <div id="footer">
 	        <xsl:value-of select="channel/copyright" />
 	    </div>
 	</body>
 	</html>
 	</xsl:template>
 	</xsl:stylesheet>
'! !

!RRStylesThree methodsFor: 'path' stamp: 'pmm 4/20/2007 23:26'!
updateRoot: aHtmlRoot
	aHtmlRoot stylesheet beXsl url: (self urlOf: #styleXsl)! !

WAFileLibrary subclass: #RRStylesTwo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RSS-Examples'!

!RRStylesTwo methodsFor: 'accessing' stamp: 'pmm 4/20/2007 23:06'!
selectorsToInclude
	^#(
		styleCss
		style2Css
	)! !

!RRStylesTwo methodsFor: 'css' stamp: 'pmm 4/20/2007 23:04'!
style2Css
	^'
channel link, channel language, channel copyright, channel managingEditor, channel webMaster, channel docs, channel lastBuildDate {
	    display:none;
}
rss {
 	    font-family:Verdana, Arial, Helvetica, sans-serif;
 	    font-size:0.7em;
 	    line-height:130%;
 	    margin:1em;
 }
/* HEADER */
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
channel title {
 	    display:block;
 	    padding:0.4em 0.2em;
 	    color:#FFF;
 	    border-bottom:1px solid black;
 	    font-weight:bold;
 	    font-size:140%;
 	    background-color:#4483C7;
}
channel description {
 	    display:block;
 	    float:left;
 	    font-size:130%;
 	    font-weight:bold;
 	    margin:0.5em;
}
/* CONTENT */
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
channel item {
 	    background-color:#FFFFEE;
 	    border:1px solid #538620;
 	    clear:both;
 	    display:block;
 	    padding:0 0 0.5em;
 	    margin:1em;
}
channel item title {
 	    background-color:#538620;
 	    border-bottom-width:0;
 	    color:#FFF;
 	    display:block;
 	    font-size:110%;
 	    font-weight:bold;
 	    margin:0;
 	    padding:0.3em 0.5em;
}
channel item description {
 	    display: block;
 	    float:none;
 	    margin:0;
 	    text-align: left;
 	    padding:0.2em 0.5em 0.4em;
 	    color: black;
 	    font-size:100%;
 	    font-weight:normal;
}
channel item link {
 	    color:#666;
 	    display:block;
 	    font-size:86%;
 	    padding:0 0.5em;
}
channel item pubDate {
 	    color:#666;
 	    display:block;
 	    font-size:86%;
	    padding:0 0.5em;
}
'! !

!RRStylesTwo methodsFor: 'css' stamp: 'pmm 4/20/2007 23:04'!
styleCss
	^'
channel link, channel language, channel copyright, channel managingEditor, channel webMaster, channel docs, channel lastBuildDate {
	    display:none;
}
rss {
 	    font-family:Verdana, Arial, Helvetica, sans-serif;
 	    font-size:0.7em;
 	    line-height:130%;
 	    margin:1em;
 }
/* HEADER */
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
channel title {
 	    display:block;
 	    padding:0.4em 0.2em;
 	    color:#FFF;
 	    border-bottom:1px solid black;
 	    font-weight:bold;
 	    font-size:140%;
 	    background-color:#4483C7;
}
channel description {
 	    display:block;
 	    float:left;
 	    font-size:130%;
 	    font-weight:bold;
 	    margin:0.5em;
}
/* CONTENT */
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
channel item {
 	    background-color:#FFFFEE;
 	    border:1px solid #538620;
 	    clear:both;
 	    display:block;
 	    padding:0 0 0.5em;
 	    margin:1em;
}
channel item title {
 	    background-color:#538620;
 	    border-bottom-width:0;
 	    color:#FFF;
 	    display:block;
 	    font-size:110%;
 	    font-weight:bold;
 	    margin:0;
 	    padding:0.3em 0.5em;
}
channel item description {
 	    display: block;
 	    float:none;
 	    margin:0;
 	    text-align: left;
 	    padding:0.2em 0.5em 0.4em;
 	    color: black;
 	    font-size:100%;
 	    font-weight:normal;
}
channel item link {
 	    color:#666;
 	    display:block;
 	    font-size:86%;
 	    padding:0 0.5em;
}
channel item pubDate {
 	    color:#666;
 	    display:block;
 	    font-size:86%;
	    padding:0 0.5em;
}
'! !
RRChangesDemo initialize!
RRDemo initialize!
